diff --git a/django/contrib/auth/tests/forms.py b/django/contrib/auth/tests/forms.py
index 429967c..1cac710 100644
--- a/django/contrib/auth/tests/forms.py
+++ b/django/contrib/auth/tests/forms.py
@@ -4,7 +4,7 @@ from django.core import mail
 from django.contrib.auth.models import User
 from django.contrib.auth.forms import UserCreationForm, AuthenticationForm,  PasswordChangeForm, SetPasswordForm, UserChangeForm, PasswordResetForm
 from django.test import TestCase
-
+from django.utils.translation import ugettext as _
 
 class UserCreationFormTest(TestCase):
 
@@ -19,7 +19,7 @@ class UserCreationFormTest(TestCase):
         form = UserCreationForm(data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form["username"].errors,
-                         [u'A user with that username already exists.'])
+                         [_(u'A user with that username already exists.')])
 
     def test_invalid_data(self):
         data = {
@@ -30,7 +30,7 @@ class UserCreationFormTest(TestCase):
         form = UserCreationForm(data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form["username"].errors,
-                         [u'This value may contain only letters, numbers and @/./+/-/_ characters.'])
+                         [_(u'This value may contain only letters, numbers and @/./+/-/_ characters.')])
 
 
     def test_password_verification(self):
@@ -43,7 +43,7 @@ class UserCreationFormTest(TestCase):
         form = UserCreationForm(data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form["password2"].errors,
-                         [u"The two password fields didn't match."])
+                         [_(u"The two password fields didn't match.")])
 
 
     def test_both_passwords(self):
@@ -52,16 +52,16 @@ class UserCreationFormTest(TestCase):
         form = UserCreationForm(data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form['password1'].errors,
-                         [u'This field is required.'])
+                         [_(u'This field is required.')])
         self.assertEqual(form['password2'].errors,
-                         [u'This field is required.'])
+                         [_(u'This field is required.')])
 
 
         data['password2'] = 'test123'
         form = UserCreationForm(data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form['password1'].errors,
-                         [u'This field is required.'])
+                         [_(u'This field is required.')])
 
     def test_success(self):
         # The success case.
@@ -91,7 +91,7 @@ class AuthenticationFormTest(TestCase):
         form = AuthenticationForm(None, data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form.non_field_errors(),
-                         [u'Please enter a correct username and password. Note that both fields are case-sensitive.'])
+                         [_(u'Please enter a correct username and password. Note that both fields are case-sensitive.')])
 
     def test_inactive_user(self):
         # The user is inactive.
@@ -102,7 +102,7 @@ class AuthenticationFormTest(TestCase):
         form = AuthenticationForm(None, data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form.non_field_errors(),
-                         [u'This account is inactive.'])
+                         [_(u'This account is inactive.')])
 
 
     def test_success(self):
@@ -130,7 +130,7 @@ class SetPasswordFormTest(TestCase):
         form = SetPasswordForm(user, data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form["new_password2"].errors,
-                         [u"The two password fields didn't match."])
+                         [_(u"The two password fields didn't match.")])
 
     def test_success(self):
         user = User.objects.get(username='testclient')
@@ -156,7 +156,7 @@ class PasswordChangeFormTest(TestCase):
         form = PasswordChangeForm(user, data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form["old_password"].errors,
-                         [u'Your old password was entered incorrectly. Please enter it again.'])
+                         [_(u'Your old password was entered incorrectly. Please enter it again.')])
 
 
     def test_password_verification(self):
@@ -170,7 +170,7 @@ class PasswordChangeFormTest(TestCase):
         form = PasswordChangeForm(user, data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form["new_password2"].errors,
-                         [u"The two password fields didn't match."])
+                         [_(u"The two password fields didn't match.")])
 
 
     def test_success(self):
@@ -200,7 +200,7 @@ class UserChangeFormTest(TestCase):
         form = UserChangeForm(data, instance=user)
         self.assertFalse(form.is_valid())
         self.assertEqual(form['username'].errors,
-                         [u'This value may contain only letters, numbers and @/./+/-/_ characters.'])
+                         [_(u'This value may contain only letters, numbers and @/./+/-/_ characters.')])
 
     def test_bug_14242(self):
         # A regression test, introduce by adding an optimization for the
@@ -236,7 +236,7 @@ class PasswordResetFormTest(TestCase):
         form = PasswordResetForm(data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form['email'].errors,
-                         [u'Enter a valid e-mail address.'])
+                         [_(u'Enter a valid e-mail address.')])
 
     def test_nonexistant_email(self):
         # Test nonexistant email address
@@ -244,7 +244,7 @@ class PasswordResetFormTest(TestCase):
         form = PasswordResetForm(data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form.errors,
-                         {'email': [u"That e-mail address doesn't have an associated user account. Are you sure you've registered?"]})
+                         {'email': [_(u"That e-mail address doesn't have an associated user account. Are you sure you've registered?")]})
 
     def test_cleaned_data(self):
         # Regression test
@@ -295,4 +295,4 @@ class PasswordResetFormTest(TestCase):
         form = PasswordResetForm(data)
         self.assertFalse(form.is_valid())
         self.assertEqual(form["email"].errors,
-                         [u"The user account associated with this e-mail address cannot reset the password."])
+                         [_(u"The user account associated with this e-mail address cannot reset the password.")])
diff --git a/django/contrib/auth/tests/views.py b/django/contrib/auth/tests/views.py
index 9fccb3e..2ea7b01 100644
--- a/django/contrib/auth/tests/views.py
+++ b/django/contrib/auth/tests/views.py
@@ -13,6 +13,7 @@ from django.test import TestCase
 from django.core import mail
 from django.core.urlresolvers import reverse
 from django.http import QueryDict
+from django.utils.translation import ugettext as _
 
 
 class AuthViewsTestCase(TestCase):
@@ -47,6 +48,10 @@ class AuthViewsTestCase(TestCase):
         self.assertTrue(response['Location'].endswith(settings.LOGIN_REDIRECT_URL))
         self.assertTrue(SESSION_KEY in self.client.session)
 
+    def _(self, text):
+        escape = (('&', '&amp;'), ('<', '&lt;'), ('>', '&gt;'),
+                  ("'", '&#39;'), ('"', '&quot;'))
+        return reduce(lambda x, y: x.replace(*y), escape, _(text).encode('utf-8'))
 
 class AuthViewNamedURLTests(AuthViewsTestCase):
     urls = 'django.contrib.auth.urls'
@@ -80,7 +85,7 @@ class PasswordResetTest(AuthViewsTestCase):
         response = self.client.get('/password_reset/')
         self.assertEqual(response.status_code, 200)
         response = self.client.post('/password_reset/', {'email': 'not_a_real_email@email.com'})
-        self.assertContains(response, "That e-mail address doesn&#39;t have an associated user account")
+        self.assertContains(response, self._("That e-mail address doesn't have an associated user account. Are you sure you've registered?"))
         self.assertEqual(len(mail.outbox), 0)
 
     def test_email_found(self):
@@ -115,7 +120,7 @@ class PasswordResetTest(AuthViewsTestCase):
         response = self.client.get(path)
         # redirect to a 'complete' page:
         self.assertEqual(response.status_code, 200)
-        self.assertTrue("Please enter your new password" in response.content)
+        self.assertTrue(self._(u"Please enter your new password") in response.content)
 
     def test_confirm_invalid(self):
         url, path = self._test_confirm_start()
@@ -125,19 +130,19 @@ class PasswordResetTest(AuthViewsTestCase):
 
         response = self.client.get(path)
         self.assertEqual(response.status_code, 200)
-        self.assertTrue("The password reset link was invalid" in response.content)
+        self.assertTrue(self._(u"The password reset link was invalid") in response.content)
 
     def test_confirm_invalid_user(self):
         # Ensure that we get a 200 response for a non-existant user, not a 404
         response = self.client.get('/reset/123456-1-1/')
         self.assertEqual(response.status_code, 200)
-        self.assertTrue("The password reset link was invalid" in response.content)
+        self.assertTrue(self._(u"The password reset link was invalid") in response.content)
 
     def test_confirm_overflow_user(self):
         # Ensure that we get a 200 response for a base36 user id that overflows int
         response = self.client.get('/reset/zzzzzzzzzzzzz-1-1/')
         self.assertEqual(response.status_code, 200)
-        self.assertTrue("The password reset link was invalid" in response.content)
+        self.assertTrue(self._(u"The password reset link was invalid") in response.content)
 
     def test_confirm_invalid_post(self):
         # Same as test_confirm_invalid, but trying
@@ -164,14 +169,14 @@ class PasswordResetTest(AuthViewsTestCase):
         # Check we can't use the link again
         response = self.client.get(path)
         self.assertEqual(response.status_code, 200)
-        self.assertTrue("The password reset link was invalid" in response.content)
+        self.assertTrue(self._(u"The password reset link was invalid") in response.content)
 
     def test_confirm_different_passwords(self):
         url, path = self._test_confirm_start()
         response = self.client.post(path, {'new_password1': 'anewpassword',
                                            'new_password2':' x'})
         self.assertEqual(response.status_code, 200)
-        self.assertTrue("The two password fields didn&#39;t match" in response.content)
+        self.assertTrue(self._(u"The two password fields didn't match.") in response.content)
 
 class ChangePasswordTest(AuthViewsTestCase):
 
@@ -182,7 +187,7 @@ class ChangePasswordTest(AuthViewsTestCase):
             }
         )
         self.assertEqual(response.status_code, 200)
-        self.assertTrue("Please enter a correct username and password. Note that both fields are case-sensitive." in response.content)
+        self.assertTrue(self._(u"Please enter a correct username and password. Note that both fields are case-sensitive.") in response.content)
 
     def logout(self):
         response = self.client.get('/logout/')
@@ -196,7 +201,7 @@ class ChangePasswordTest(AuthViewsTestCase):
             }
         )
         self.assertEqual(response.status_code, 200)
-        self.assertTrue("Your old password was entered incorrectly. Please enter it again." in response.content)
+        self.assertTrue(self._(u"Your old password was entered incorrectly. Please enter it again.") in response.content)
 
     def test_password_change_fails_with_mismatched_passwords(self):
         self.login()
@@ -207,7 +212,7 @@ class ChangePasswordTest(AuthViewsTestCase):
             }
         )
         self.assertEqual(response.status_code, 200)
-        self.assertTrue("The two password fields didn&#39;t match." in response.content)
+        self.assertTrue(self._(u"The two password fields didn't match.") in response.content)
 
     def test_password_change_succeeds(self):
         self.login()