diff --git a/docs/intro/tutorial01.txt b/docs/intro/tutorial01.txt
index 8474d9e..8dc05c0 100644
--- a/docs/intro/tutorial01.txt
+++ b/docs/intro/tutorial01.txt
@@ -703,10 +703,8 @@ Save these changes and start a new Python interactive shell by running
 
 For more information on model relations, see :doc:`Accessing related objects
 </ref/models/relations>`. For more on how to use double underscores to perform
-field lookups via the API, see `Field lookups`__. For full details on the
+field lookups via the API, see :ref:`Field lookups <field-lookups-intro>`. For full details on the
 database API, see our :doc:`Database API reference </topics/db/queries>`.
 
-__ http://docs.djangoproject.com/en/1.2/topics/db/queries/#field-lookups
-
 When you're comfortable with the API, read :doc:`part 2 of this tutorial
 </intro/tutorial02>` to get Django's automatic admin working.
diff --git a/docs/releases/1.0.1.txt b/docs/releases/1.0.1.txt
index 780dc53..37142a2 100644
--- a/docs/releases/1.0.1.txt
+++ b/docs/releases/1.0.1.txt
@@ -6,8 +6,9 @@ Welcome to Django 1.0.1!
 
 This is the first "bugfix" release in the Django 1.0 series, improving
 the stability and performance of the Django 1.0 codebase. As such,
-Django 1.0.1 contains no new features (and, pursuant to `our
-compatibility policy`_, maintains backwards compatibility with Django
+Django 1.0.1 contains no new features (and, pursuant to :doc:`our
+compatibility policy </misc/api-stability/>`, maintains backwards
+compatibility with Django
 1.0), but does contain a number of fixes and other
 improvements. Django 1.0.1 is a recommended upgrade for any
 development or deployment currently using or targeting Django 1.0.
@@ -46,8 +47,9 @@ highlights:
 
 * A fix to the application of autoescaping for literal strings passed
   to the ``join`` template filter. Previously, literal strings passed
-  to ``join`` were automatically escaped, contrary to `the documented
-  behavior for autoescaping and literal strings`_. Literal strings
+  to ``join`` were automatically escaped, contrary to :ref:`the
+  documented behavior for autoescaping and literal strings
+  <string-literals-and-automatic-escaping>`. Literal strings
   passed to ``join`` are no longer automatically escaped, meaning you
   must now manually escape them; this is an incompatibility if you
   were relying on this bug, but not if you were relying on escaping
@@ -60,6 +62,4 @@ highlights:
   documentation, including both corrections to existing documents and
   expanded and new documentation.
 
-.. _our compatibility policy: http://docs.djangoproject.com/en/dev/misc/api-stability/
 .. _the Subversion log of the 1.0.X branch: http://code.djangoproject.com/log/django/branches/releases/1.0.X
-.. _the documented behavior for autoescaping and literal strings: http://docs.djangoproject.com/en/dev/topics/templates/#string-literals-and-automatic-escaping
diff --git a/docs/topics/db/models.txt b/docs/topics/db/models.txt
index f907c23..65b2d59 100644
--- a/docs/topics/db/models.txt
+++ b/docs/topics/db/models.txt
@@ -324,11 +324,10 @@ whatever you want. For example::
     should work; all are optional.
 
     For details on accessing backwards-related objects, see the
-    `Following relationships backward example`_.
+    :ref:`Following relationships backward example <backwards-related-objects>`.
 
     For sample code, see the `Many-to-one relationship model tests`_.
 
-    .. _Following relationships backward example: http://docs.djangoproject.com/en/dev/topics/db/queries/#backwards-related-objects
     .. _Many-to-one relationship model tests: http://code.djangoproject.com/browser/django/trunk/tests/modeltests/many_to_one
 
 Many-to-many relationships
diff --git a/docs/topics/templates.txt b/docs/topics/templates.txt
index 719fc67..17e5d69 100644
--- a/docs/topics/templates.txt
+++ b/docs/topics/templates.txt
@@ -556,6 +556,8 @@ to any variable that needs escaping. When auto-escaping is on, there's no
 danger of the :tfilter:`escape` filter *double-escaping* data -- the
 :tfilter:`escape` filter does not affect auto-escaped variables.
 
+.. _string-literals-and-automatic-escaping:
+
 String literals and automatic escaping
 --------------------------------------
 